#!/bin/sh
clear

# Info
echo -e "\n - Script for batch convert your zso disc images to iso format."
echo -e "\n   rev 2022-05-15"
echo -e "\n   Author: Okeanos"
echo -e "\n - Credits:\n   Open PS2 Loader Team\n   Acid_Snake\n   Virtuous Flame"
echo -e "\n\n * Disclaimer"
echo -e "   This script is provided without any warranty."
echo -e "\n\n ... Press a key to continue, or press 'CTRL+C' to exit ..."
read -rsn 1 -p ""
#clear

# Prerequisites check
echo -e "\n\n- Prerequisites check ..."
echo -e "\nsearching for python package manager:"
if pip -V | grep -qs python3; then echo -e "found. ok."; else echo -e "not found ... first install:\n\npython-pip\n\n\n... Press a key to exit ...\n"; read -rsn 1 -p ""; exit; fi
#if pip list | grep "lz4"; then continue; else echo -e "lz4 missing ... first install it with:\n\npip install lz4\n\n... Press a key to exit ...\n"; read -rsn 1 -p ""; exit; fi
echo -e "\nsearching for python lz4 package:"
pip show lz4> /dev/null 2>&1; if [[ $? -ne 0 ]]; then echo -e "not found ... first install it with:\n\npip install lz4\n\n\n... Press a key to exit ...\n"; read -rsn 1 -p ""; exit; else echo -e "found. ok."; fi
echo -e "\nsearching for ziso.py script:"
if [[ ! -f ./ziso.py ]]; then echo -e "not found ... please place it in the script folder.\n\n\n... Press a key to exit ...\n"; read -rsn 1 -p ""; exit; else echo -e "found. ok."; fi

# Variables
x=0
y=0
ext="zso"
in="ZSO"
out="ISO"
log="${0##*/}.log"
if [ -f "$log" ] ; then rm "$log" ; fi

if [[ ! -d $in ]] ; then mkdir -p "$in"; fi
if [[ ! -d $in ]] ; then echo -e "... error, $in directory missing ...\n\n... Press a key to exit ...\n"; read -rsn 1 -p ""; exit; fi
if [[ ! -d $out ]] ; then mkdir -p "$out"; fi
if [[ ! -d $out ]] ; then echo -e "... error, $out directory missing ...\n\n... Press a key to exit ...\n"; read -rsn 1 -p ""; exit; fi

echo

echo -e "\n - Now put your files in $in folder ... Press a key to continue ...\n"
read -rsn 1 -p ""
clear

# Processing
echo -e "\n - Processing files:"

while IFS= read -r -d $'\0' var; do
    name=${var##*/}
    namenoprefix=${var#*.*.}
    #echo " example: fullname = ${var##*/} | name after prefix with dots = ${var#*.*.} | ext = ${var##*.} | name = ${name%.*} "
    if [ -f "./$out/${name%.*}.iso" ]; then
        y=$(($y+1))
        echo -e "\n[ ] ${var##*/}"
        echo "[ ] ${var##*/}" >> "$log"
    else
        x=$(($x+1))
        echo -e "\n[+] ${var##*/}"
        ./ziso.py -c 0 -m "$in/${var##*/}" "$out/${name%.*}.iso"
        echo "[+] ${var##*/}" >> "$log"
    fi
done < <(read -r -a MY_ARR <<< "$ext"
            for i in "${MY_ARR[@]}"; do
                find "$in" -type f -iname "*.$i" -print0
            done )

echo -e "\n\n - Info:\n[+] processed\n[ ] skipped, already processed"

# Results
echo -e "\n\n - Results:"
if [ $x = 0 ] ; then echo -e "\n   No file to process found ..."
    if [ $y -ne 0 ] ; then echo -e "\n   Skipped files:    $y"; fi
else echo -e "\n   Processed files: $x"
    if [ $y -ne 0 ] ; then echo -e "\n   Skipped files:    $y\n\n   Total files:     $(($x+$y))"; fi
fi

echo

# Log
if [[ $x -ne 0 ]] ; then while :; do
    read -rp " - Open the log? [s/N]: " ans
        if [[ -z $ans ]] ; then break
            elif [[ $ans = [Ss] ]] ; then xdg-open "$log" ; break
            elif [[ $ans = [Nn] ]] ; then break
        fi
    done
fi

echo

# End
read -rsn 1 -p "... End. Press a key to exit ..."
echo -e "\n"
exit
